/*  mul   #xxxx,>yy   xxxx is xrefed wrong */
/*  st    >[..],<..  */
/*  ld    <....,>... */



#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <alloc.h>

#define X_JMP    0
#define X_CALL   1
#define X_IMM    2
#define X_TABLE  3
#define X_DIRECT 4
#define X_DATA   5

struct addrlist {
  int addr;
  int type;
  struct addrlist far *n;
};

struct xref {
  int ref;
  struct addrlist far *list;
  struct xref far *n;
} far *xref;

unsigned int minxref=0;
unsigned int maxxref=0xffff;
long missedxrefs=0L;

char instrlen[]={
/* 0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f  */
   2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3,   /* 0 */
   0, 2, 2, 2, 0, 2, 2, 2, 3, 3, 3, 0, 0, 0, 0, 0,   /* 1 */
   2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,   /* 2 */
   3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,   /* 3 */
   4, 5, 4,-5, 4, 5, 4,-5, 4, 5, 4,-5, 4, 5, 4,-5,   /* 4 */
   4, 4, 4,-5, 4, 4, 4,-5, 4, 4, 4,-5, 4, 4, 4,-5,   /* 5 */
   3, 4, 3,-4, 3, 4, 3,-4, 3, 4, 3,-4, 3, 4, 3,-4,   /* 6 */
   3, 3, 3,-4, 3, 3, 3,-4, 3, 3, 3,-4, 3, 3, 3,-4,   /* 7 */
   3, 4, 3,-4, 3, 4, 3,-4, 3, 4, 3,-4, 3, 4, 3,-4,   /* 8 */
   3, 3, 3,-4, 3, 3, 3,-4, 3, 3, 3,-4, 3, 3, 3,-4,   /* 9 */
   3, 4, 3,-4, 3, 4, 3,-4, 3, 4, 3,-4, 3, 3, 3,-4,   /* a */
   3, 3, 3,-4, 3, 3, 3,-4, 3, 3, 3,-4, 3, 3, 3,-4,   /* b */
   3, 3, 3,-4, 3, 3, 3,-4, 2, 3, 2,-3, 2, 0, 2,-3,   /* c */
   2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,   /* d */
   3, 3, 0, 2, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 3,   /* e */
   1, 0, 1, 1, 1, 1, 2, 0, 1, 1, 1, 1, 1, 1,-7, 1
};
/*

00100bbb xxxxxxxx    -> sjmp  bbbxxxxxxxx
00101bbb xxxxxxxx    -> scall bbbxxxxxxxx
00110bbb src ofs     -> jbc src, bb, ofs
00111bbb src ofs     -> jbs src, bb, ofs
010....0   b0 b1 b2
010...01   b0 b1 b2 b3
010...11   b0 b1 b2 b3 b4  (b4 als b0&1)
0110...0   b0 b1
0110..01   b0 b1 b2
0110..11   b0 b1 b2 b3  (b3 als b0&1)
0111...0   b0 b1
0111..01   b0 b1
0111..11   b0 b1 b2 b3  (b3 als b0&1)
10.0...0   b0 b1
10.0..01   b0 b1 b2
10.0..11   b0 b1 b2 b3  (b3 als b0&1)
10.1...0   b0 b1
10.1..01   b0 b1
10.1..11   b0 b1 b2 b3  (b3 als b0&1)
11001..0   b0
11000..0   b0 b1
11001001   b0 b1
11001.11   b0 b1 b2   (b2 als b0&1)
11000.11   b0 b1 b2 b3  (b3 als b0&1)
1101....   ofs      j.. ofs
*/

/*
   0 = unknown opcode
   >0 = # bytes
   <0 : +1 if 2nd byte odd
   -7 : extended opcode
*/

/*
01.t00..  and     b
01.t01..  add     b
01.t10..  sbb     b
01.t11..  mulu    b
100t00..  or      b
100t01..  xor     b
100t10..  cmp     b
100t11..  divu    b
101t00..  ld      b
101t01..  addc    b
101t10..  subc    b
101t11..  ldbse  /ze
*/

#define DISASSM 0
#define DUMP    1
#define STRINGS 2
#define END     3
#define WORDS   4
#define CH_WORD 5
#define CH_BYTE 6
#define BYTE_CH 7

char datchars[]="cdsewxyz";

char *inputfile;

struct fmt {
  int mode;
  int addr;
  struct fmt *n;
} *list;

char *opcodes1[]={"and","add","sbb","mulu","and","add","sbb","mulu",
                  "or","xor","cmp","divu","ld","addc","subc","ldbse"
};

/* 000txxxx */
char *opcodes0[]={"skip","clr","not","neg","","dec","ext","inc",
                  "shr","shl","shra","","shrl","shll","shral","norm",
                  "","clrb","notb","negb","","decb","extb","incb",
                  "shrb","shlb","shrab","","","","",""
};
/* 1101xxxx */
char *opcodes2[]={"jnst","jnh","jgt","jnc","jnvt","jnv","jge","jne",
                  "jst", "jh", "jle","jc", "jvt", "jv", "jlt","je"
};

/* 1110xxxx */
char *opcodes3[]={"djnz","djnzw","","br","","","","ljmp",
                  "","","","","","","","lcall"
};

/* 1111xxxx */
char *opcodes4[]={"ret","","pushf","popf","pusha","popa","idlpd","",
                  "clrc","setc","di","ei","clrvt","nop","","rst"
};

/* 1100xxxx */
char *opcodes5[]={"st","bmov","st","st","stb","cmpl","stb","stb",
                  "push","push","push","push","pop","pop","","pop"
};

/* 11111110 bb.b....   */
char *opcodes6[]={"","","mul","mulb","mul","mulb","div","divb","",""};

void addxref(int type, int addr, int ref)
{
  struct xref far *p;
  struct xref far *q;
  struct addrlist far *new;
  if (minxref>(unsigned)ref || (unsigned)ref>maxxref) return;
  new=(struct addrlist far *)farmalloc(sizeof(struct addrlist));
  if (new==NULL)  /* out of memory */
  {
    missedxrefs++;
    return;
  }
  new->addr=addr;
  new->type=type;

  p=xref;  q=NULL;
  while (p!=NULL && (unsigned)ref>(unsigned)p->ref)
  {
    q=p; p=p->n;
  }

  if (p!=NULL && ref==p->ref)  /* new addr for ref */
  {
    new->n=p->list;
    p->list=new;
  }
  else /* insert */
  {
    new->n=NULL;
    if (q==NULL)
    {
      q=(struct xref far *)farmalloc(sizeof(struct xref));
      if (q==NULL)
      {
        missedxrefs++;
        farfree(new);
        return;
      }
      xref=q;
    }
    else
    {
      q->n=(struct xref far *)farmalloc(sizeof(struct xref));
      if (q->n==NULL)
      {
        missedxrefs++;
        farfree(new);
        return;
      }
      q=q->n;
    }
    q->n=p;
    q->list=new;
    q->ref=ref;
  }
}

void dumpxref(void)
{
  struct xref far *p;
  struct addrlist far *q;

  for (p=xref ; p!=NULL ; p=p->n)
  {
    printf("%04x : ",p->ref);
    for (q=p->list ; q!=NULL ; q=q->n)
    {
      switch(q->type)
      {
        case X_CALL : putchar('*'); break;
        case X_JMP  : putchar('$'); break;
        case X_IMM  : putchar('#'); break;
        case X_TABLE: putchar('>'); break;
        default:
          printf("\nILLEGAL XREF TYPE %d, addr=%04x. Aborting..\n",
            q->type,q->addr);
          return;
      }
      printf("%04x ",q->addr);
    }
    putchar('\n');
  }
}

int extendedopc(int addr,FILE *f)
{
  int opc, opidx;
  int buf[10];  int n=0;
  int i;
  opc=getc(f);  buf[n++]=opc;
  opidx=0;
  if (opc&0x80) opidx|=4;
  if (opc&0x40) opidx|=2;
  if (opc&0x10) opidx|=1;
  buf[n++]=getc(f);
  buf[n++]=getc(f);
  if (opc<0x60)
    buf[n++]=getc(f);
  if ((opc&0x1f)==0x0d )
    buf[n++]=getc(f);
  else if ((opc&0x0f)==0x0f && buf[1]&1)
    buf[n++]=getc(f);
/*
  for (i=1 ; i<n ; i++)
    printf("%02x",buf[i]);
  for (i=n ; i<8 ; i++)
    printf("  ");
*/
  printf("%-6s  ",opcodes6[opidx]);
  i=1;
  switch(buf[0]&0x3)
  {
    case 0: printf("<%02x,",buf[i++]); break;
    case 1:
      if (buf[0]&0x10)
        printf("#%02x,",buf[i++]);
      else
      {
        printf("#%04x,",*(int *)(buf+i));
        addxref(X_IMM,addr-n,*(int *)(buf+i));
        i+=2;
      }
      break;
    case 2:
      if (buf[1]&1)
        printf("<[%02x]+,",buf[i++]);
      else
        printf("<[%02x],",buf[i++]);
      break;
    case 3:
      printf("<[%02x]",buf[i++]);
      if (buf[1]&1)
      {
        printf("%04x,",*(int *)(buf+i));
        addxref(X_DATA,addr-n,*(int *)(buf+i));
        i+=2;
      }
      else
        printf("%02x,",buf[i++]);
      break;
  }
  if (buf[0]<0x60) printf("<%02x,",buf[i++]);
  printf(">%02x",buf[i++]);
  while (i<n)
    printf("   !%02x",buf[i++]);


  return(n+1);
}

void do_sjmp(int addr, unsigned char *buf, int n)
{
  int ofs;
  ofs=((buf[0]&3)<<8)|buf[1];
  if (buf[0]&4) ofs|=0xfc00;
  printf("sjmp    $%04x",addr+ofs);
  addxref(X_JMP,addr-n,addr+ofs);
}

void do_scall(int addr, unsigned char *buf, int n)
{
  int ofs;
  ofs=((buf[0]&3)<<8)|buf[1];
  if (buf[0]&4) ofs|=0xfc00;
  printf("scall   $%04x",addr+ofs);
  addxref(X_CALL,addr-n,addr+ofs);
}

void do_jbc(int addr, unsigned char *buf, int n)
{
  printf("jbc     <%02x,%d,$%04x",buf[1],buf[0]&7,addr+(char)buf[2]);
  addxref(X_JMP,addr-n,addr+(char)buf[2]);
}

void do_jbs(int addr, unsigned char *buf, int n)
{
  printf("jbs     <%02x,%d,$%04x",buf[1],buf[0]&7,addr+(char)buf[2]);
  addxref(X_JMP,addr-n,addr+(char)buf[2]);
}

void do_condjmp(int addr, unsigned char *buf, int n)
{
  printf("%-6s  $%04x",opcodes2[buf[0]&0xf],addr+(char)buf[1]);
  addxref(X_JMP,addr-n,addr+(char)buf[1]);
}

void do_f0(int addr, unsigned char *buf, int n)
{
  printf("%s",opcodes4[buf[0]&15]);
}

void do_middle(int addr, unsigned char *buf, int n)
{
    /* compute index : bit 7532 of buf[0] */
  int op;
  int i;
  op=0;
  if (buf[0]&0x80) op|=8;
  if (buf[0]&0x20) op|=4;
  if (buf[0]&0x08) op|=2;
  if (buf[0]&0x04) op|=1;
  printf("%s%c",opcodes1[op],(buf[0]&0x10)?'b':' ');
  for (i=strlen(opcodes1[op]) ; i<7 ; i++)
    putchar(' ');
  i=1;
  switch(buf[0]&0x3)
  {
    case 0: printf("<%02x,",buf[i++]); break;
    case 1:
      if (buf[0]&0x10)
        printf("#%02x,",buf[i++]);
      else
      {
        printf("#%04x,",*(int *)(buf+i));
        addxref(X_IMM,addr-n,*(int *)(buf+i));
        i+=2;
      }
      break;
    case 2:
      if (buf[1]&1)
        printf("<[%02x]+,",buf[i++]);
      else
        printf("<[%02x],",buf[i++]);
      break;
    case 3:
      printf("<[%02x]",buf[i++]);
      if (buf[1]&1)
      {
        printf("%04x,",*(int *)(buf+i));
        addxref(X_DATA,addr-n,*(int *)(buf+i));
        i+=2;
      }
      else
        printf("%02x,",buf[i++]);
      break;
  }
  if (buf[0]<0x60) printf("<%02x,",buf[i++]);
  printf(">%02x",buf[i++]);
  while (i<n)
    printf("   !%02x",buf[i++]);
}

void do_00(int addr, unsigned char *buf, int n)
{
  int i=1;
  printf("%-6s  ",opcodes0[buf[0]&31]);
  if (buf[0]&8)
    if (buf[i]<16)
      printf(" #%x,",buf[i++]);
    else
      printf(" <%02x,",buf[i++]);
  printf(">%02x",buf[i++]);
}

void do_c0(int addr, unsigned char *buf, int n)
{

  if (buf[0]&0x8)
  {
    printf("%-6s  %02x %02x",opcodes5[buf[0]&0xf],buf[1],buf[2]);
    if (n==4)
      printf(" %02x",buf[3]);
  }
  else if ((buf[0]&3)==1)
  {
    printf("%-6s  %02x %02x",opcodes5[buf[0]&0xf],buf[1],buf[2]);
    if (n==4)
      printf(" %02x",buf[3]);
  }
  else  /* st... */
  {
    printf("%-6s  <%02x >[%02x]",opcodes5[buf[0]&0xf],buf[2],buf[1]);
    if (n==4)
      printf(" %02x",buf[3]);
  }
}



void do_e0(int addr, unsigned char *buf, int n)
{
  switch(buf[0])
  {
    case 0xe0:
      printf("djnz    <%02x,$%04x",buf[1],addr+(char)buf[2]);
      addxref(X_JMP,addr-n,addr+(char)buf[2]);
      break;
    case 0xe1:
      printf("djnzw   $%02x,$%04x",buf[1],addr+(char)buf[2]);
      addxref(X_JMP,addr-n,addr+(char)buf[2]);
      break;
    case 0xe3: printf("br      [<%02x]",buf[1]); break;
    case 0xe7:
      printf("ljmp    $%04x",addr+*(int *)(buf+1));
      addxref(X_JMP,addr-n,addr+*(int *)(buf+1));
      break;
    case 0xef:
      printf("lcall   $%04x",addr+*(int *)(buf+1));
      addxref(X_CALL,addr-n,addr+*(int *)(buf+1));
      break;
    default:  printf("????");
  }

}

int addlist(int addr,int mode)
{
  struct fmt *p=list, *q=NULL;
  while (p!=NULL && p->addr<addr)
  {
    q=p;
    p=p->n;
  }
  if (q==NULL)
  {
    q=(struct fmt *)malloc(sizeof(struct fmt));
    if (q==NULL)
    {
      printf("Out of memory reading config. Aborting\n");
      return(-1);
    }
    list=q;
  }
  else
  {
    q->n=(struct fmt *)malloc(sizeof(struct fmt));
    if (q==NULL)
    {
      printf("Out of memory reading config. Aborting\n");
      return(-1);
    }
    q=q->n;
  }
  q->addr=addr;
  q->mode=mode;
  q->n=p;
  return(0);
}

int readlist(char *name)
{
  FILE *f;
  char buf[80], *p, *q;
  int addr;  int cmd;
  f=fopen(name,"r");
  if (f==NULL) return(-1);
  list=NULL;
  while ((p=fgets(buf,80,f))!=NULL)
  {
    buf[strlen(buf)-1]=0;    /* clear newline char */
    for (q=datchars ; *q!=0 && *q!=p[0] ; q++) ;
    if (*q)
    {
      sscanf(p+1,"%x",&addr);
      if (addlist(addr,q-datchars)<0) return(-1);
    }
    else
      switch(p[0])
      {
        case 'f':  /* inputfile */
          inputfile=(char *)malloc(strlen(p));
          if (inputfile==NULL)
          {
            printf("Out of memory allocating string. Aborting\n");
            return(-1);
          }
          strcpy(inputfile,p+1);
          break;
        case 'r':
          if (p[1]=='0')
            sscanf(p+2,"%x",&minxref);
          else
            sscanf(p+2,"%x",&maxxref);
          break;
      }
  }
  fclose(f);
  return(0);
}

void main(int argc, char **argv)
{
  FILE *f;
  int opc;
  int c;
  int addr, startaddr;
  int i;
  int mode;
  unsigned char buf[8]; int n;
  if (argc<2) return;
  if (readlist(argv[1])<0) return;
  f=fopen(inputfile,"rb");
  if (argc==3)
  {
    sscanf(argv[2],"%x",&startaddr);
		fseek(f,(unsigned long)startaddr-list->addr,SEEK_SET);
    while (startaddr>list->addr)  list=list->n;
    addr=startaddr;
  }
  else
    addr=list->addr;
  mode=list->mode;
  list=list->n;
  xref=NULL;
  while (!feof(f) && !kbhit() && list!=NULL)
  {
    if (addr>=list->addr)
    {
      mode=list->mode;
      list=list->n;
    }
    if (mode==DISASSM)
    {
      printf("%04x    ",addr);
      opc=getc(f);  /* printf("%02x",opc); */
      if (opc==0xfe)
      {
        addr+=extendedopc(addr,f);
        putchar('\n');
        continue;
      }
      n=instrlen[opc];  buf[0]=opc;
      if (n<0)
      {
        n=-n;
        buf[1]=getc(f);  if (buf[1]&1) n++;
        for (i=2 ; i<n ; i++)
          buf[i]=getc(f);
      }
      else
        for (i=1 ; i<n ; i++)
          buf[i]=getc(f);
      addr+=n;
/*
      for (i=1 ; i<n ; i++)
        printf("%02x",buf[i]);
      for (i=n ; i<6 ; i++)
        printf("  ");
*/
      if (n==0)
      {
        printf("???\n");  addr++;
        continue;
      }
      if ((opc&0xf8)==0x20)      do_sjmp(addr,buf,n);
      else if ((opc&0xf8)==0x28) do_scall(addr,buf,n);
      else if ((opc&0xf8)==0x30) do_jbc(addr,buf,n);
      else if ((opc&0xf8)==0x38) do_jbs(addr,buf,n);
      else if ((opc&0xf0)==0xd0) do_condjmp(addr,buf,n);
      else if ((opc&0xf0)==0xf0) do_f0(addr,buf,n);
      else if ((opc&0xf0)==0xe0) do_e0(addr,buf,n);
      else if ((opc&0xf0)==0xc0) do_c0(addr,buf,n);
      else if ((opc&0xe0)==0)    do_00(addr,buf,n);
      else                       do_middle(addr,buf,n);
      putchar('\n');
    }
    else if (mode==DUMP)
    {
      i=0;
      while (addr<list->addr)
      {
        if ((i&15)==0) printf("%04x    DB      ",addr);
        printf("%02x ",(unsigned char)getc(f)); addr++;
        if ((i&15)==15) putchar('\n');
        i++;
      }
      if (i&15) putchar('\n');
      mode=list->mode; list=list->n;
    }
    else if (mode==STRINGS)
    {
      while (addr<list->addr)
      {
        printf("%04x    DB      '",addr);
        while ( (c=getc(f))!=0)
        {
          if (c<' '||c>'~')
            printf("\\%02x",(unsigned char)c);
          else
            putchar(c);
          addr++;
        }
        printf("',0\n"); addr++;
      }
      mode=list->mode; list=list->n;
    }
    else if (mode==WORDS)
    {
      i=0;
      while (addr<list->addr)
      {
        if ((i&7)==0) printf("%04x    DW      ",addr);
        c=(unsigned char)getc(f); addr++;
        c=c| ((unsigned char)getc(f)<<8); addr++;
        printf("%04x ",c);
        addxref(X_TABLE,addr-2,c);
        if ((i&7)==7) putchar('\n');
        i++;
      }
      if (i&7) putchar('\n');
      mode=list->mode; list=list->n;
    }
    else if (mode==CH_WORD)
    {
      i=0;
      while (addr<list->addr)
      {
        if ((i&3)==0) printf("%04x    DW      ",addr);
        printf("'%c',",getc(f));  addr++;
        c=(unsigned char)getc(f); addr++;
        c=c| ((unsigned char)getc(f)<<8); addr++;
        printf("%04x ",c);
        addxref(X_TABLE,addr-3,c);
        if ((i&3)==3) putchar('\n');
        i++;
      }
      if (i&3) putchar('\n');
      mode=list->mode; list=list->n;
    }
    else if (mode==CH_BYTE)
    {
      i=0;
      while (addr<list->addr)
			{
				if ((i&7)==0) printf("%04x    DB      ",addr);
        printf("'%c',",getc(f));  addr++;
        printf("%02x, ",getc(f));  addr++;
        if ((i&7)==7) putchar('\n');
        i++;
      }
      if (i&7) putchar('\n');
      mode=list->mode; list=list->n;
    }
    else if (mode==BYTE_CH)
    {
      i=0;
      while (addr<list->addr)
      {
				if ((i&7)==0) printf("%04x    DB      ",addr);
        printf("%02x,",getc(f));  addr++;
        printf("'%c' ",getc(f));  addr++;
        if ((i&7)==7) putchar('\n');
        i++;
      }
      if (i&7) putchar('\n');
      mode=list->mode; list=list->n;
    }
    else if (mode==END)
      list=NULL;
  }
  fclose(f);
  printf("\n\nXREFS : (missed : %ld)\n\n",missedxrefs);
  dumpxref();
}
